/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef mapview_tile_provider_base_h
#define mapview_tile_provider_base_h

#include "mapview_types.h"
#include "qad_map_export.h"

#include <QObject>
#include <QPixmap>
#include <pivaluetree.h>


class QAD_MAP_EXPORT MapViewTileProviderBase: public QObject {
	Q_OBJECT

public:
	MapViewTileProviderBase() {}
	virtual ~MapViewTileProviderBase() {}

	const PIValueTree & getParameters() const { return parameters; }
	void setParameters(const PIValueTree & vt);

	virtual QString name() const                            = 0;
	virtual bool requestTile(MapViewTypes::TileIndex index) = 0;
	virtual QSize tileSize()                                = 0;
	virtual QString cacheDir() const { return name(); }
	virtual int maximumLevel() const = 0;

protected:
	void initParameters(const PIValueTree & vt);

	virtual void applyParameters() {}

private:
	void applyParametersIntenal();
	PIValueTree parameters;

signals:
	void tileReady(MapViewTypes::TileIndex index, QPixmap pm);
	void parametersChanged();
};


#endif
